<?php

namespace Meibuyu\Micro\Shoplazza;

use Hyperf\Contract\ContainerInterface;

class ShoplazzaFactory
{

    /**
     * @var ContainerInterface
     */
    private $container;

    public function __construct(ContainerInterface $container)
    {
        $this->container = $container;
    }

    public function create(array $config = []): ShoplazzaApp
    {
        if (method_exists($this->container, 'make')) {
            // Create by DI for AOP.
            return $this->container->make(ShoplazzaApp::class, ['config' => $config]);
        }
        return new ShoplazzaApp($config);
    }

}
